(*****************************************************************************
 *          HOL-TestGen - specification based test case generation
 *                                                                            
 * List.sml- Wrapper for calling C implementation 
 * Copyright (C) 2005 Achim D. Brucker <brucker@inf.ethz.ch>   
 *                    Burkhart Wolff   <bwolff@inf.ethz.ch>    
 *                                                                            
 * This file is part of HOL-TestGen.                  
 *                                                                            
 * HOL-TestGen is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the Free   
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-TestGen is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
 * more details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ******************************************************************************)

structure myList = struct

val csort = _import "sort": int array * int -> int array;

fun ArrayToList a = Array.foldl (op ::) [] a;
(* Note, the conversion from List to Array and vice versa is only
   neded because our C implementation works over Arrays whereas 
   our specification is defined over lists. *)
fun sort list = ArrayToList (csort(Array.fromList(list),(length list)));


end

