header {* Testing Properties of Red-Black Trees *}


theory 
  RBT_test
imports 
  RBT_def
  Testing
begin


section {* Test Specification and Test-Case-Generation *}

test_spec "(isord t \<and> isin (y::int) t \<and> strong_redinv t & blackinv t)
           \<longrightarrow> (blackinv(prog(y,t)))"
apply(gen_test_cases 3 1 "prog")
store_test_thm "red-and-black-inv"

section {* Test Data Generation *}
subsection {* Brute Force *}

testgen_params [iterations=40]

gen_test_data "red-and-black-inv"

thm "red-and-black-inv.test_data"




subsection {* An Alternative Approach with a little Theorem Proving *}
    
lemma height_0: 
   "(max_B_height x = 0) = 
    (x = E \<or> (\<exists> a y b. x = T R a y b \<and> 
                       (max (max_B_height a) (max_B_height b)) = 0))";
  by(induct "x", simp_all,case_tac "color",auto)


lemma max_B_height_dec : 
"((max_B_height (T x t1 val t3)) = 0) \<Longrightarrow> (x = R) "
  by(case_tac "x",auto)


test_spec "(isord t & isin (y::int) t & strong_redinv t & blackinv t)
           \<longrightarrow> (blackinv(prog(y,t)))"
apply(gen_test_cases 3 1 "prog" simp: max_B_height_dec)
apply(simp_all only: height_0, simp_all add: max_0_0)
apply(simp_all only: height_0, simp_all add: max_0_0)
apply(safe)
apply(tactic "ALLGOALS(fn n => TRY(TestGen.var_hyp_subst_tac n))")
apply(simp_all)
store_test_thm "red-and-black-inv2"

testgen_params [iterations=40]

gen_test_data "red-and-black-inv2"

thm "red-and-black-inv2.test_data"
thm "red-and-black-inv.test_data"


end
